hdu 2955 Robberies(概率背包)

Robberies

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 22658    Accepted Submission(s): 8358

Problem Description

The aspiring Roy the Robber has seen a lot of American movies, and knows that the bad guys usually gets caught in the end, often because they become too greedy. He has decided to work in the lucrative business of bank robbery only for a short while, before retiring to a comfortable job at a university.


For a few months now, Roy has been assessing the security of various banks and the amount of cash they hold. He wants to make a calculated risk, and grab as much money as possible.

His mother, Ola, has decided upon a tolerable probability of getting caught. She feels that he is safe enough if the banks he robs together give a probability less than this.

Input

The first line of input gives T, the number of cases. For each scenario, the first line of input gives a floating point number P, the probability Roy needs to be below, and an integer N, the number of banks he has plans for. Then follow N lines, where line j gives an integer Mj and a floating point number Pj .
Bank j contains Mj millions, and the probability of getting caught from robbing it is Pj .

Output

For each test case, output a line with the maximum number of millions he can expect to get while the probability of getting caught is less than the limit set.

Notes and Constraints
0 < T <= 100
0.0 <= P <= 1.0
0 < N <= 100
0 < Mj <= 100
0.0 <= Pj <= 1.0
A bank goes bankrupt if it is robbed, and you may assume that all probabilities are independent as the police have very low funds.

Sample Input

3
0.04 3
1 0.02
2 0.03
3 0.05
0.06 3
2 0.03
2 0.03
3 0.05
0.10 3
1 0.03
2 0.02
3 0.05

Sample Output

2
4
6


对于该题,第一遍拿概率作为背包容量dp(看样例好像最多两位),结果错了。

发觉最多只有1w个银行,于是我选择拿银行数量作为背包容量,然后去求出每个银行数最大逃跑的概率(1-被抓概率)。

接着银行从大到小找一遍,最大的且逃跑概率大于等于逃跑总概率(1-被抓总概率n)的银行数即为答案。

#include<cstdio>
#include<iostream>
#include<cstring>
#include<cmath>
#define clr(x) memset(x,0,sizeof(x))
#define MIN 1e-9
using namespace std;
double val[100010];
struct node
{
    int cost;
    double val;
}bank[200];
double d,m;
int T,n,ans,all;
int main()
{
    scanf("%d",&T);
    while(T--)
    {
        scanf("%lf%d",&m,&n);
        all=0;
        m=1-m;
        for(int i=1;i<=n;i++)
        {
            scanf("%d%lf",&bank[i].cost,&bank[i].val);
            all+=bank[i].cost;
        }
        clr(val);
        val[0]=1;
        for(int i=1;i<=n;i++)
            for(int j=all;j>=bank[i].cost;j--)
            {
                if(val[j]<(1-bank[i].val)*val[j-bank[i].cost])
                    val[j]=(1-bank[i].val)*val[j-bank[i].cost];
            }
        for(int i=all;i>=0;i--)
        {
            if(val[i]>=m || m-val[i]<MIN)
            {
                ans=i;
                break;
            }
        }
        printf("%d\n",ans);
    }
    return 0;
}
时间: 2024-08-21 22:26:23

hdu 2955 Robberies(概率背包)的相关文章

HDU 2955 Robberies --01背包变形

这题有些巧妙,看了别人的题解才知道做的. 因为按常规思路的话,背包容量为浮点数,,不好存储,且不能直接相加,所以换一种思路,将背包容量与价值互换,即令各银行总值为背包容量,逃跑概率(1-P)为价值,即转化为01背包问题. 此时dp[v]表示抢劫到v块钱成功逃跑的概率,概率相乘. 最后从大到小枚举v,找出概率大于逃跑概率的最大v值,即为最大抢劫的金额. 代码: #include <iostream> #include <cstdio> #include <cstring>

HDU 2955 Robberies (01背包)

Robberies Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 11297    Accepted Submission(s): 4190 Problem Description The aspiring Roy the Robber has seen a lot of American movies, and knows that

hdu 2955 Robberies 0-1背包/概率初始化

/*Robberies Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 13854 Accepted Submission(s): 5111 Problem Description The aspiring Roy the Robber has seen a lot of American movies, and knows that the

HDU 2955 Robberies dp +背包

题目链接~~http://acm.hdu.edu.cn/showproblem.php?pid=2955 题意 : 在不被抓住的情况下,偷的钱最多, 然后题目给的是被抓住的概率~ 就可以考虑在不被抓住的情况下,拿的最多的钱.. 还RT了一回    %>_<% 状态方程: dp[j]=max(dp[j],dp[j-a[i]]*p1[i]); 代码:: 1 #include <iostream> 2 #include <cstdio> 3 #include <cmat

hdu 2955 Robberies (01背包好题)

Robberies Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 31769    Accepted Submission(s): 11527 Problem Description The aspiring Roy the Robber has seen a lot of American movies, and knows that

hdu 2955 Robberies(背包DP)

题意: 小偷去抢银行,他母亲很担心. 他母亲希望他被抓的概率真不超过P.小偷打算去抢N个银行,每个银行有两个值Mi.Pi,Mi:抢第i个银行所获得的财产 Pi:抢第i个银行被抓的概率 求最多能抢得多少财产. 思路: 由于概率不是整数,所以不能将其作为背包容量.继续观察,发现Mi是整数,调整思路可发现,可以将财产作为背包容量,求一定财产内的被抓的最小概率.这样只需要判断这个概率是否小于等于P即可. 代码: double P; int N; int m[105]; double p[105]; do

HDU 2955 Robberies(01 背包)

#include<cstdio> #include<cstring> #include<iostream> #include<algorithm> using namespace std; struct Node { int m; double p; }; Node bank[200]; double dp[100000]; int main() { int t,n; double p; int i,j,k; scanf("%d",&am

HDU 2955 Robberies (背包)

Description The aspiring Roy the Robber has seen a lot of American movies, and knows that the bad guys usually gets caught in the end, often because they become too greedy. He has decided to work in the lucrative business of bank robbery only for a s

HDU 2955 Robberies 背包概率DP

A - Robberies Time Limit:1000MS     Memory Limit:32768KB     64bit IO Format:%I64d & %I64u Submit Status Practice HDU 2955 Appoint description: Description The aspiring Roy the Robber has seen a lot of American movies, and knows that the bad guys usu